aboutsummaryrefslogtreecommitdiffstats
diff options
context:
space:
mode:
-rw-r--r--.github/workflows/kernel.yml8
-rwxr-xr-x.github/workflows/scripts/show_build_failures.sh15
-rw-r--r--.github/workflows/tools.yml2
3 files changed, 20 insertions, 5 deletions
diff --git a/.github/workflows/kernel.yml b/.github/workflows/kernel.yml
index 62e0952f19..5afd546394 100644
--- a/.github/workflows/kernel.yml
+++ b/.github/workflows/kernel.yml
@@ -150,22 +150,22 @@ jobs:
- name: Build tools
shell: su buildbot -c "sh -e {0}"
working-directory: openwrt
- run: make tools/install -j$(nproc) BUILD_LOG=1
+ run: make tools/install -j$(nproc) BUILD_LOG=1 || ret=$? .github/workflows/scripts/show_build_failures.sh
- name: Build toolchain
shell: su buildbot -c "sh -e {0}"
working-directory: openwrt
- run: make toolchain/install -j$(nproc) BUILD_LOG=1
+ run: make toolchain/install -j$(nproc) BUILD_LOG=1 || ret=$? .github/workflows/scripts/show_build_failures.sh
- name: Build Kernel
shell: su buildbot -c "sh -e {0}"
working-directory: openwrt
- run: make target/compile -j$(nproc) BUILD_LOG=1
+ run: make target/compile -j$(nproc) BUILD_LOG=1 || ret=$? .github/workflows/scripts/show_build_failures.sh
- name: Build Kernel Kmods
shell: su buildbot -c "sh -e {0}"
working-directory: openwrt
- run: make package/linux/compile -j$(nproc) BUILD_LOG=1
+ run: make package/linux/compile -j$(nproc) BUILD_LOG=1 || ret=$? .github/workflows/scripts/show_build_failures.sh
- name: Upload logs
if: failure()
diff --git a/.github/workflows/scripts/show_build_failures.sh b/.github/workflows/scripts/show_build_failures.sh
new file mode 100755
index 0000000000..14f699c93d
--- /dev/null
+++ b/.github/workflows/scripts/show_build_failures.sh
@@ -0,0 +1,15 @@
+#!/bin/bash
+
+original_exit_code="${ret:-1}"
+log_dir_path="${1:-logs}"
+context="${2:-10}"
+
+show_make_build_errors() {
+ grep -slr 'make\[[[:digit:]]\].*Error [[:digit:]]$' "$log_dir_path" | while IFS= read -r log_file; do
+ printf "====== Make errors from %s ======\n" "$log_file";
+ grep -r -C"$context" 'make\[[[:digit:]]\].*Error [[:digit:]]$' "$log_file" ;
+ done
+}
+
+show_make_build_errors
+exit "$original_exit_code"
diff --git a/.github/workflows/tools.yml b/.github/workflows/tools.yml
index 4e423fdd62..b97f0599e2 100644
--- a/.github/workflows/tools.yml
+++ b/.github/workflows/tools.yml
@@ -123,7 +123,7 @@ jobs:
- name: Build tools
run: |
cd "$WORKPATH"
- make tools/install -j$(nproc) BUILD_LOG=1
+ make tools/install -j$(nproc) BUILD_LOG=1 || ret=$? .github/workflows/scripts/show_build_failures.sh
- name: Move logs to GITHUB_WORKSPACE
if: always()